using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BeWo.Data.Access;
using BeWo.Data.Entities;
using BeWo.Report;
using BeWo.Report.ReportObjects;
using DevExpress.XtraReports.UI;

namespace VSDHammReports
{
	public class VsdHammReportCreator : DefaultReportCreator
	{
		public override XtraReport CreateServiceOverviewAllCustomersReport(int month, int year, long orgaOid, long empOid, long? serviceCategoryOid, int startDay, int endDay)
		{
			List<ServicesOverviewRO> lROs = ServicesOverviewRO.Create(month, year, orgaOid, empOid, startDay, endDay);

			if (lROs.Count > 0)
			{

				var rootReport = CreateServicesOverviewReportForRo(lROs[0], serviceCategoryOid);
				rootReport.CreateDocument();

				for (int i = 1; i < lROs.Count; i++)
				{
					var lNext = CreateServicesOverviewReportForRo(lROs[i], serviceCategoryOid);
					lNext.CreateDocument();
					rootReport.Pages.AddRange(lNext.Pages);
				}

				return rootReport;
			}
			return new XtraReport();
		}

		public override XtraReport CreateServiceOverviewSingleCustomerReport(long customerOid, int month, int year, long orgaOid, long empOid, long? serviceCategoryOid, int startDay, int endDay)
		{
			var ro = ServicesOverviewRO.Create(customerOid, month, year, false, orgaOid, empOid, startDay, endDay, serviceCategoryOid);

			return CreateServicesOverviewReportForRo(ro, serviceCategoryOid);

		}

		private XtraReport CreateServicesOverviewReportForRo(ServicesOverviewRO ro, long? serviceCategoryOid)
		{
			IBeWoReport<ServicesOverviewRO> report = null;

			if (ro.Costbearer.Contains("Jugendamt") || ro.Costbearer == "Jugendamt der Stadt Aachen" || ro.Costbearer == "Jugendamt der Stadt Hamm" || ro.Costbearer == "Stadt Hamm Jugendamt Clearing" || ro.Costbearer == "Jugendamt Kreis Soest" || ro.Costbearer == "Stadt Hamm Jugendamt Wohnprojekt")
			{
				report = new VSDHammReports.QuittierungsbelegJAHamm();
			}
			
			if (report == null)
				report = new VSDHammReports.Stundenzettel();
			report.SetReportDataSource(ro);

			return report as XtraReport;
		}
	}
}
